//=================================================================================//
//
// UNITED BOT - FRAME WORK
//
// 
// This work is based off several pieces of code by several authors. In no specific
// order:
// 
// Jeffrey "botman" Broome
// Cheeseh
// Stefan Hendriks
// 
//
//=================================================================================//

#include <stdio.h>

// HACK HACK HACK : BASEENTITY ACCESS
#include "cbase.h"
#include "baseentity.h"
// HACK HACK HACK : BASEENTITY ACCESS

#include "interface.h"
#include "filesystem.h"
#include "engine/iserverplugin.h"
#include "dlls/iplayerinfo.h"
#include "eiface.h"
#include "igameevents.h"
#include "IEffects.h"


#include "usercmd.h"
#include "bitbuf.h"
#include "in_buttons.h"

//#include "mathlib.h"

#include "ubbot.h"
#include "ubbot_util.h"

// memdbgon must be the last include file in a .cpp file!!!
#include "tier0/memdbgon.h"

#define BUF_SIZE 64  // really only need 249 bits (32 bytes) + WEAPON_SUBTYPE_BITS (whatever that is)

bot_t gBots[32];                    // bot private data stuff (see bot.h file for details)
wpt_t gWaypoints[MAX_WAYPOINTS];    // waypoint data


///////////////////////////////////////////////////////////////////////////////
// Function : CreateBot()
// Arguments: 2
// Usage    : Creates a bot with name & sets desired team
// Author   : Jeffrey "botman" Broome , changed by Stefan Hendriks
// Errormsg : YES
///////////////////////////////////////////////////////////////////////////////
void CreateBot(const char* name, int iTeam)
{
	edict_t *pEdict = engine->CreateFakeClient( name );

	if (!pEdict)
	{
		Msg("CreateBot: ERROR - Counldn't create a bot.\n");
		return;
	}

    if (iTeam < 0)
    {
        // set random team
        iTeam = RANDOM_INT(3) + 1;  // 1 is spectator...
    }

//	ClientPutInServer(pEdict, name);  // you don't need this for bots in Source

//	pPlayer->ClearFlags();
//	pPlayer->AddFlag( FL_CLIENT | FL_FAKECLIENT );

	bot_t *pBot = &gBots[ engine->IndexOfEdict(pEdict) - 1 ];

	// initialize any private bot data here...
	pBot->edict = pEdict;

    // HACK HACK - cBaseEntity stuff - START
    
    // HACK 1: GET TO BASE ENTITY FIRST
    pBot->pBaseEntity = CBaseEntity::Instance(pEdict);// get the player entity
    pBot->pPlayerEnt = NULL;
    
    if ( pBot->pBaseEntity && pBot->pBaseEntity->IsPlayer() )
    {
        // HACK 2 : GET TO PLAYER ENTITY
        pBot->pPlayerEnt = static_cast< CBasePlayer * >( pBot->pBaseEntity );
    }
    else
    {
        // fail
        Msg("Could not set pBaseEntity and pPlayerEnt!\n");
    }

    if (!pBot->pPlayerEnt)
    {
        // fail here
        Msg("Failed to set pPlayerEnt");
    }

    // end method of SteveC
    // HACK HACK - cBaseEntity stuff - END

	
    pBot->fCreateTime = engine->Time();
	pBot->fJoinTime = pBot->fCreateTime + 1.0;  // time when bot does stuff to join game (team select, etc)
    
    pBot->fMoveSpeed  = 0.0;    // move speed
    pBot->fSideSpeed  = 0.0;    // side speed
    pBot->fShootTime  = 0.0;    // when > engine->Time() , shoot.

    // Team
    pBot->iTeam = iTeam;

    // Location
    pBot->vMyOrigin = Vector(0,0,0);

    // Moving (body)
    pBot->vMoveToVector = Vector(0,0,0);            // where to move to
    pBot->vPrevMoveToVector = Vector(0,0,0);        // previous move to
    
    // Aiming (head)
    pBot->vLookAtVector = Vector(0,0,0);

	Msg("CreateBot: bot was added successfully to server.\n");
}

///////////////////////////////////////////////////////////////////////////////
// Function : BotMoveToVector()
// Arguments: 3
// Usage    : Pass bot or edict_t and moving vector to set the 'move to vector'
// Author   : Stefan Hendriks
// Errormsg : YES
///////////////////////////////////////////////////////////////////////////////
void BotMoveToVector(bot_t *pBot, edict_t *pEdict, Vector vDir)
{
    // Check if vDir is valid (ie, not 0,0,0)
    if (vDir == Vector(0,0,0))
    {
        Msg("ERROR: BotMoveToVector() got invalid vDir\n");
        return;
    }

 
    // First check if the given arguments are correct:
    if (pEdict == NULL) 
    {
        // check if pBot is given
        if (pBot)
            pEdict = pBot->edict;
        else
        {
            Msg("ERROR: BotMoveToVector() could not get edict_t\n");
            return; // get out
        }
    }
        
    // Get pBot
    if (pEdict && pBot==NULL)
        bot_t *pBot = &gBots[ engine->IndexOfEdict(pEdict) - 1 ];
    
    if (pBot == NULL)
    {
        Msg("ERROR: BotMoveToVector() could not get bot_t\n");
        return;
    }

   
    // Substract
    vDir = vDir - pBot->vMyOrigin;

    // And set to go
    pBot->vMoveToVector = vDir;   // Move to this direction
}

///////////////////////////////////////////////////////////////////////////////
// Function : BotRunPlayerMove()
// Arguments: 1
// Usage    : Pass bot pointer, runs ProcessUserCmd to let bot do what it should
//            do. First version made by botman, additions by Stefan Hendriks
// Author   : Jeffrey "botman" Broome , changed by Stefan Hendriks
// Errormsg : NO
// Comments :
//            see CBasePlayer::RunNullCommand() for example of PlayerRunCommand()...
///////////////////////////////////////////////////////////////////////////////
void BotRunPlayerMove(bot_t* pBot)
{
	CUserCmd cmd;
	bf_write write_buf;
	bf_read read_buf;
	unsigned char buffer[BUF_SIZE];  // shared buffer between write_buf and read_buf (EVIL!!!)

	memset(&cmd, 0, sizeof(cmd));

	cmd.forwardmove = 0;                    // forward speed only set when moving
	cmd.sidemove    = pBot->fSideSpeed;     // side speed set immidiatly
	cmd.upmove      = 0;
	cmd.buttons     = 0;                    // fire etc
    cmd.impulse     = 0;                    // weapons selection
    cmd.mousedx     = 0;
    cmd.mousedy     = 0;

    QAngle AngleWeMoveTo;       // the angle we move to

    // Until arrived: (Stefan)
    if (pBot->vMoveToVector != pBot->vPrevMoveToVector)
    {
        // Set move speed
        cmd.forwardmove = pBot->fMoveSpeed;

        UTIL_VectorAngles( pBot->vMoveToVector, cmd.viewangles );
        
        AngleWeMoveTo = cmd.viewangles;
        
        // clamp the pitch and yaw (as seen in the sdk)
        if (cmd.viewangles[0] > 180)
            cmd.viewangles[0] -= 360;

        if (cmd.viewangles[1] > 180)
            cmd.viewangles[1] -= 360;
    }
    else
    {
        // set it up here
        UTIL_VectorAngles( pBot->vMoveToVector, AngleWeMoveTo);        
    }
    
    // Shoot when told to: (Stefan)
    if (pBot->fShootTime < engine->Time())
    {
        pBot->fShootTime = engine->Time() + 1.0;
        // fire
        cmd.buttons |= IN_ATTACK;        

    }

	
//	if ( pPlayer->IsDead() ) // respawn dead players
//	{
//		if (RandomInt(0,1))
//			cmd.buttons = 0;
//		else
//			cmd.buttons = IN_ATTACK;
//	}
    
    Vector vMoveDir;
    Vector vLookDir;
    
    pBot->vLookAtVector = pBot->vMoveToVector; // ITS THE SAME

    vLookDir = pBot->vLookAtVector;     // look at this

    AngleVectors(AngleWeMoveTo, &vMoveDir);	// get movement direction
    
    // move in vMoveDir
    // dot product vMoveDir onto vLookDir to get forward movement
    
    float fForwardDot=DotProduct(vMoveDir, vLookDir);	// get the proportion of forwards
    
    Vector vRightLook, vUpLook;
    VectorVectors(vLookDir, vRightLook, vUpLook);	// get the vector perpendicular to the forward vector
    
    float fSideDot=DotProduct(vMoveDir, vRightLook);	// get the proportion of side
    
    
    cmd.forwardmove=fForwardDot*200.0f;
    cmd.sidemove=fSideDot*200.0f;



	write_buf.StartWriting( buffer, BUF_SIZE );

	WriteUsercmd( &write_buf, &cmd );  // by magic the same data appears in the read_buf!!!

	read_buf.StartReading( buffer, BUF_SIZE );  // this is truly EVIL!!!

    // PROCESS AIMING    
    engine->CrosshairAngle( pBot->edict, 100, 100 );

    // PROCESS MOVEMENT
	gameclients->ProcessUsercmds(pBot->edict, &read_buf, 1, 1, 0, false, false);
    

    

}

///////////////////////////////////////////////////////////////////////////////
// Function : BotUpdateStatus()
// Arguments: 1
// Usage    : Pass bot pointer, updates status framerate-wise
// Author   : Stefan Hendriks
// Errormsg : NO
///////////////////////////////////////////////////////////////////////////////
void BotUpdateStatus(bot_t *pBot)
{
    // HACK HACK (from SteveC)
    // this changes the fixangle from absolute (which isn't coded for) to none
	// note: has to be run here because it doesn't work in the addbot routine?!?!?
	if (pBot->pPlayerEnt->PlayerData()->fixangle!=FIXANGLE_NONE)	
        pBot->pPlayerEnt->PlayerData()->fixangle=FIXANGLE_NONE;
    


    // When we already joined the game for one second, only then do this
    if ((pBot->fJoinTime > 0.0f) && (pBot->fJoinTime + 1 < engine->Time()))
    {
        IPlayerInfo* pInfo = playerinfomanager->GetPlayerInfo(pBot->edict);
        
        // Set team (in case the game dll changed it for us)
        pBot->iTeam = pInfo->GetTeamIndex();
    }

    // Set 'my origin'    
    gameclients->ClientEarPosition( pBot->edict, &pBot->vMyOrigin );
    //UTIL_GetEntityOrigin(pBot->edict);    -> does not work!?
}

///////////////////////////////////////////////////////////////////////////////
// Function : BotJoinGame()
// Arguments: 1
// Usage    : Pass bot pointer, joins game -> Joins now given iTeam value
// Author   : Jeffrey "botman" Broome , changed by Stefan Hendriks
// Errormsg : NO
///////////////////////////////////////////////////////////////////////////////
void BotJoinGame(bot_t* pBot)
{
	// do whatever is necessary here to join the game...
	IPlayerInfo* pInfo = playerinfomanager->GetPlayerInfo(pBot->edict);

    pInfo->ChangeTeam(pBot->iTeam);
}

///////////////////////////////////////////////////////////////////////////////
// Function : BotMoveThink()
// Arguments: 1
// Usage    : Pass bot pointer, walks any path given (or chases enemy) and
//            sets move speed for that
// Author   : Stefan Hendriks
// Errormsg : NO
///////////////////////////////////////////////////////////////////////////////
void BotMoveThink(bot_t *pBot)
{
    pBot->fMoveSpeed = 0.0;
    // do something

    if (pBot->vMoveToVector != pBot->vPrevMoveToVector)
        pBot->fMoveSpeed = 200.0;
}

///////////////////////////////////////////////////////////////////////////////
// Function : BotThink()
// Arguments: 1
// Usage    : Pass bot pointer, main thinking function
//            * extra functionality added by Stefan Hendriks
// Author   : Jeffrey "botman" Broome , changed by Stefan Hendriks
// Errormsg : NO
///////////////////////////////////////////////////////////////////////////////
void BotThink(edict_t* pEdict)
{
    // Bot pointer
	bot_t *pBot = &gBots[ engine->IndexOfEdict(pEdict) - 1 ];

    // First update status
    BotUpdateStatus(pBot);

	float current_time = engine->Time();

    // Join the game
	if ((pBot->fJoinTime > 0.0f) && (pBot->fJoinTime < current_time))
	{
		BotJoinGame(pBot);
		pBot->fJoinTime = -1.0f;  // don't need to join game now
	}

    if (pHostEdict)
    {
        // move to the listen server        
        Vector hostvec; /* = UTIL_GetEntityOrigin(pHostEdict);*/
        gameclients->ClientEarPosition( pHostEdict, &hostvec );
        BotMoveToVector(pBot, pEdict, hostvec);
/*
        int iResult = UTIL_InFieldOfView(pBot->edict, hostvec, pBot->vMoveToVector);
        char msg[80];
        sprintf(msg, "UTIL_InFieldOfView returns %d\n", iResult);
        Msg(msg);*/
        
    }
    
    BotMoveThink(pBot);           // path/move thinking    
	BotRunPlayerMove(pBot);       // aka HL1 RunPlayerMove
}
