//=============================================================================//
//
// HPB_bot2.h - bot header file (Copyright 2004, Jeffrey "botman" Broome)
//
//=============================================================================//

#ifndef HPB_BOT2_H
#define HPB_BOT2_H

#include "usercmd.h"


#define PHYSGUN_BEAM_SPRITE		"sprites/physbeam.vmt"

#define GOAL_TERROR_SPAWN       1
#define GOAL_COUNTER_SPAWN      2
#define GOAL_BOMBSPOT           3

#define MAX_WAYPOINTS           1024

// BOT_T Structure
typedef struct
{
	edict_t*	edict;
    
    CBaseEntity *pBaseEntity;     // pointer to base entity of bot (HACK HACK)
    CBasePlayer *pPlayerEnt;      // pointer to player entity of bot (HACK HACK)


	float		fCreateTime;	// time bot was created
	float		fJoinTime;		// time when bot should do stuff to join the game (select team, etc)
        
    float       fMoveSpeed;     // the move speed of the bot , set earlier
    float       fSideSpeed;     // the side speed of the bot , set earlier

    int         iTeam;          // the team the bot should join
                                // FIXME: make it also change when team is forced to another
                                //        so it can be used for knowing which team ur on.

    Vector vMyOrigin;           // Where am i?
    
    Vector vMoveToVector;       // Where should the bot move to?
    Vector vPrevMoveToVector;   // Previous move to vector

    Vector vLookAtVector;       // Where should i look at?
    

    // testing
    float fShootTime;

} bot_t;

// WAYPOINT_T Structure
typedef struct
{
    Vector Origin;              // Location of waypoint
    int    iGoal;               // is it a goal?
    int    iNeighbours[8];      // maximum of 8 connecting waypoints
} wpt_t;


// Interfaces from the engine
extern IVEngineServer *engine;  // helper functions (messaging clients, loading content, making entities, running commands, etc)
extern IFileSystem *filesystem;  // file I/O 
extern IGameEventManager *gameeventmanager;  // game events interface
extern IPlayerInfoManager *playerinfomanager;  // game dll interface to interact with players
extern IServerPluginHelpers *helpers;  // special 3rd party plugin helpers from the engine
extern IServerGameClients* gameclients;
extern IEffects *effects;

// Our own waypoint data externally available
extern wpt_t gWaypoints[MAX_WAYPOINTS];    // waypoint data
extern int  gWaypointSprite;
extern edict_t *pHostEdict;        // the first human edict joining the game (= listen server)

// function prototypes...
void CreateBot(const char* name, int iTeam);
void BotThink(edict_t* pEdict);
void WriteUsercmd( bf_write *buf, CUserCmd *cmd );

// Added by Stefan Hendriks
void BotMoveToVector(bot_t *pBot, edict_t *pEdict, Vector vDir);


// Waypoint stuff
void WaypointInit();
void WaypointAdd(Vector v);
void WaypointDraw(edict_t *pEdict);

void WaypointLoad(char filename[80]);
void WaypointSave(char filename[80]);

int WaypointClose(Vector v);
void WaypointGoal(int iIndex, int iGoal);


// REMOVED THESE:
// REMOVED DUE THE HACK HACK HACK

// useful helper funcs...
/*
inline bool FStrEq(const char *sz1, const char *sz2)
{
	return(Q_stricmp(sz1, sz2) == 0);
}

/*
inline edict_t* INDEXENT( int iEdictNum )		
{ 
	return engine->PEntityOfEntIndex(iEdictNum); 
}*/

#endif // HPB_BOT2_H
