//=================================================================================//
//
// UNITED BOT - FRAME WORK
//
// 
// This work is based off several pieces of code by several authors. In no specific
// order:
// 
// Jeffrey "botman" Broome
// Cheeseh
// Stefan Hendriks
// 
//
//=================================================================================//

#include <stdio.h>
#include <time.h>

// HACK HACK HACK : BASEENTITY ACCESS
#include "cbase.h"
#include "baseentity.h"
// HACK HACK HACK : BASEENTITY ACCESS

#include "interface.h"
#include "filesystem.h"
#include "engine/iserverplugin.h"
#include "dlls/iplayerinfo.h"
#include "eiface.h"
#include "igameevents.h"
#include "IEffects.h"
#include "convar.h"
#include "Color.h"

#include "ubbot.h"

// memdbgon must be the last include file in a .cpp file!!!
#include "tier0/memdbgon.h"

// Interfaces from the engine
IVEngineServer                  *engine = NULL;  // helper functions (messaging clients, loading content, making entities, running commands, etc)
IFileSystem                     *filesystem = NULL;  // file I/O 
IGameEventManager               *gameeventmanager = NULL;  // game events interface
IPlayerInfoManager              *playerinfomanager = NULL;  // game dll interface to interact with players
IServerPluginHelpers            *helpers = NULL;  // special 3rd party plugin helpers from the engine
IServerGameClients              *gameclients = NULL;
IEffects                        *effects = NULL;


bool bMapInitialized=false;
bool bDrawWaypoints=false;
int  gWaypointSprite=-1;
edict_t *pHostEdict = NULL;        // the first human edict joining the game (= listen server)
char gMapName[80];

extern bot_t gBots[];


// function to initialize any cvars/command in this plugin
void InitCVars( CreateInterfaceFn cvarFactory );


//---------------------------------------------------------------------------------
// Purpose: a sample 3rd party plugin class
//---------------------------------------------------------------------------------
class CUBBOT_Plugin: public IServerPluginCallbacks, public IGameEventListener
{
public:
	CUBBOT_Plugin();
	~CUBBOT_Plugin();

	// IServerPluginCallbacks methods
	virtual bool			Load(	CreateInterfaceFn interfaceFactory, CreateInterfaceFn gameServerFactory );
	virtual void			Unload( void );
	virtual void			Pause( void );
	virtual void			UnPause( void );
	virtual const char     *GetPluginDescription( void );      
	virtual void			LevelInit( char const *pMapName );
	virtual void			ServerActivate( edict_t *pEdictList, int edictCount, int clientMax );
	virtual void			GameFrame( bool simulating );
	virtual void			LevelShutdown( void );
	virtual void			ClientActive( edict_t *pEntity );
	virtual void			ClientDisconnect( edict_t *pEntity );
	virtual void			ClientPutInServer( edict_t *pEntity, char const *playername );
	virtual void			SetCommandClient( int index );
	virtual void			ClientSettingsChanged( edict_t *pEdict );
	virtual PLUGIN_RESULT	ClientConnect( bool *bAllowConnect, edict_t *pEntity, const char *pszName, const char *pszAddress, char *reject, int maxrejectlen );
	virtual PLUGIN_RESULT	ClientCommand( edict_t *pEntity );
	virtual PLUGIN_RESULT	NetworkIDValidated( const char *pszUserName, const char *pszNetworkID );

	// IGameEventListener Interface
	virtual void FireGameEvent( KeyValues * event );

	virtual int GetCommandIndex() { return m_iClientCommandIndex; }
private:
	int m_iClientCommandIndex;
};


// 
// The plugin is a static singleton that is exported as an interface
//
CUBBOT_Plugin g_HPBBOTServerPlugin;
EXPOSE_SINGLE_INTERFACE_GLOBALVAR(CUBBOT_Plugin, IServerPluginCallbacks, INTERFACEVERSION_ISERVERPLUGINCALLBACKS, g_HPBBOTServerPlugin );

//---------------------------------------------------------------------------------
// Purpose: constructor/destructor
//---------------------------------------------------------------------------------
CUBBOT_Plugin::CUBBOT_Plugin()
{
	m_iClientCommandIndex = 0;
}

CUBBOT_Plugin::~CUBBOT_Plugin()
{
}

//---------------------------------------------------------------------------------
// Purpose: called when the plugin is loaded, load the interface we need from the engine
//---------------------------------------------------------------------------------
bool CUBBOT_Plugin::Load(	CreateInterfaceFn interfaceFactory, CreateInterfaceFn gameServerFactory )
{
    MathLib_Init(1.0,1.0,1.0,1.0,false,true,false,true);

    // clear out mapname
    memset(gMapName, 0, sizeof(gMapName));

	playerinfomanager = (IPlayerInfoManager *)gameServerFactory(INTERFACEVERSION_PLAYERINFOMANAGER,NULL);
	if ( !playerinfomanager )
	{
		Warning( "Unable to load playerinfomanager, ignoring\n" ); // this isn't fatal, we just won't be able to access specific player data
	}

	// get the interfaces we want to use
	if(	!(engine = (IVEngineServer*)interfaceFactory(INTERFACEVERSION_VENGINESERVER, NULL)) ||
		!(gameeventmanager = (IGameEventManager *)interfaceFactory(INTERFACEVERSION_GAMEEVENTSMANAGER,NULL)) ||
		!(filesystem = (IFileSystem*)interfaceFactory(FILESYSTEM_INTERFACE_VERSION, NULL)) ||
		!(helpers = (IServerPluginHelpers*)interfaceFactory(INTERFACEVERSION_ISERVERPLUGINHELPERS, NULL))
		)
	{
		Warning( "Some Interface couldn't be created!  Shutting down plugin...\n" ); // this isn't fatal, we just won't be able to access specific player data
		return false; // we require all these interface to function
	}

	gameclients = (IServerGameClients*)gameServerFactory(INTERFACEVERSION_SERVERGAMECLIENTS, NULL);
    if ( !gameclients )
	{
        Msg("PLUGIN: Unable to load gameclients, unloading plugin...\n");
		return false;
	}

    effects = (IEffects*)gameServerFactory(IEFFECTS_INTERFACE_VERSION, NULL); 
    if (!effects)
    {
        Msg("PLUGIN: Unable to load the effects library, unloading plugin...\n");
        return false;
    }

	InitCVars( interfaceFactory ); // register any cvars we have defined



	srand( (unsigned)time(NULL) );  // initialize the random seed

	return true;
}

//---------------------------------------------------------------------------------
// Purpose: called when the plugin is unloaded (turned off)
//---------------------------------------------------------------------------------
void CUBBOT_Plugin::Unload( void )
{
	gameeventmanager->RemoveListener( this ); // make sure we are unloaded from the event system
}

//---------------------------------------------------------------------------------
// Purpose: called when the plugin is paused (i.e should stop running but isn't unloaded)
//---------------------------------------------------------------------------------
void CUBBOT_Plugin::Pause( void )
{
}

//---------------------------------------------------------------------------------
// Purpose: called when the plugin is unpaused (i.e should start executing again)
//---------------------------------------------------------------------------------
void CUBBOT_Plugin::UnPause( void )
{
}

//---------------------------------------------------------------------------------
// Purpose: the name of this plugin, returned in "plugin_print" command
//---------------------------------------------------------------------------------
const char *CUBBOT_Plugin::GetPluginDescription( void )
{
	return "UB-Bot Framework by Bots-United (Botman, Stefan Hendriks)";
}

//---------------------------------------------------------------------------------
// Purpose: called on level start
//---------------------------------------------------------------------------------
void CUBBOT_Plugin::LevelInit( char const *pMapName )
{
	Msg( "Level \"%s\" has been loaded\n", pMapName );
    
    // Initialize
    bMapInitialized=true;
    bDrawWaypoints=false;

    //ar filename[80];
    //sprintf(filename, "%s", pMapName);
    sprintf(gMapName, "%s", pMapName);

    WaypointInit();    
    WaypointLoad(gMapName);

    // Precache sprite
    gWaypointSprite = engine->PrecacheModel(PHYSGUN_BEAM_SPRITE);

    if (gWaypointSprite > -1)
        Msg("WAYPOINT: Sprite loaded.\n");

	gameeventmanager->AddListener( this, true );
}

//---------------------------------------------------------------------------------
// Purpose: called on level start, when the server is ready to accept client connections
//		edictCount is the number of entities in the level, clientMax is the max client count
//---------------------------------------------------------------------------------
void CUBBOT_Plugin::ServerActivate( edict_t *pEdictList, int edictCount, int clientMax )
{
	Msg( "clientMax is %d\n", clientMax );
}

//---------------------------------------------------------------------------------
// Purpose: called once per server frame, do recurring work here (like checking for timeouts)
//---------------------------------------------------------------------------------
void CUBBOT_Plugin::GameFrame( bool simulating )
{    
    if (bMapInitialized == false)
        return;     // do nothing here while map is not yet initalized

    Vector vDir = Vector(0,0,0);

	for ( int i = 1; i <= 32; i++ )  // EVIL: shouldn't just assume maxplayers is 32!!!
	{
		edict_t *pPlayerEdict = INDEXENT( i );

        if (pPlayerEdict)   // valid edict        
        {            
            // FIXME:
            // When this is a normal player, and we have no host edict set yet, assume it?

            // When this is a bot, and in our list (this plugin), run think function
            if ( !pPlayerEdict->IsFree() && gBots[i-1].edict == pPlayerEdict) // fake client
            {                
                BotThink( pPlayerEdict );                
            }        
        }
	}

    if (pHostEdict && bDrawWaypoints)
        WaypointDraw(pHostEdict);
}

//---------------------------------------------------------------------------------
// Purpose: called on level end (as the server is shutting down or going to a new map)
//---------------------------------------------------------------------------------
void CUBBOT_Plugin::LevelShutdown( void ) // !!!!this can get called multiple times per map change
{
	gameeventmanager->RemoveListener( this );
    // un-initialize level
    bMapInitialized=false;  // stefan
    bDrawWaypoints=false;
    pHostEdict = NULL;     // remove host edict
}

//---------------------------------------------------------------------------------
// Purpose: called when a client spawns into a server (i.e as they begin to play)
//---------------------------------------------------------------------------------
void CUBBOT_Plugin::ClientActive( edict_t *pEntity )
{
    // TODO: do a dedicated server check on this?!?
    if (pHostEdict == NULL)
    {
        Msg("PLUGIN: Host edict found and set\n");
        pHostEdict = pEntity;
    }
}

//---------------------------------------------------------------------------------
// Purpose: called when a client leaves a server (or is timed out)
//---------------------------------------------------------------------------------
void CUBBOT_Plugin::ClientDisconnect( edict_t *pEntity )
{
    // remove bot
    if (pEntity == pHostEdict)
        pHostEdict= NULL;
}

//---------------------------------------------------------------------------------
// Purpose: called on client being added to this server
//---------------------------------------------------------------------------------
void CUBBOT_Plugin::ClientPutInServer( edict_t *pEntity, char const *playername )
{
}

//---------------------------------------------------------------------------------
// Purpose: called on level start
//---------------------------------------------------------------------------------
void CUBBOT_Plugin::SetCommandClient( int index )
{
	m_iClientCommandIndex = index;
}

//---------------------------------------------------------------------------------
// Purpose: called on level start
//---------------------------------------------------------------------------------
void CUBBOT_Plugin::ClientSettingsChanged( edict_t *pEdict )
{
	if ( playerinfomanager )
	{
		IPlayerInfo *playerinfo = playerinfomanager->GetPlayerInfo( pEdict );

		const char * name = engine->GetClientConVarValue( engine->IndexOfEdict(pEdict), "name" );

		if ( playerinfo && name && playerinfo->GetName() && 
			 Q_stricmp( name, playerinfo->GetName()) ) // playerinfo may be NULL if the MOD doesn't support access to player data 
													   // OR if you are accessing the player before they are fully connected
		{
			char msg[128];
			Q_snprintf( msg, sizeof(msg), "Your name changed to \"%s\" (from \"%s\"\n", name, playerinfo->GetName() ); 
			engine->ClientPrintf( pEdict, msg ); // this is the bad way to check this, the better option it to listen for the "player_changename" event in FireGameEvent()
												// this is here to give a real example of how to use the playerinfo interface
		}
	}
}

//---------------------------------------------------------------------------------
// Purpose: called when a client joins a server
//---------------------------------------------------------------------------------
PLUGIN_RESULT CUBBOT_Plugin::ClientConnect( bool *bAllowConnect, edict_t *pEntity, const char *pszName, const char *pszAddress, char *reject, int maxrejectlen )
{
	return PLUGIN_CONTINUE;
}

//---------------------------------------------------------------------------------
// Purpose: called when a client types in a command (only a subset of commands however, not CON_COMMAND's)
//---------------------------------------------------------------------------------
PLUGIN_RESULT CUBBOT_Plugin::ClientCommand( edict_t *pEntity )
{
	const char *pcmd = engine->Cmd_Argv(0);

    Vector hostvec = Vector(0,0,0);

    // get vector when host edict is known
    if (pHostEdict)    
        gameclients->ClientEarPosition( pHostEdict, &hostvec );

	if ( !pEntity || pEntity->IsFree() ) 
	{
		return PLUGIN_CONTINUE;
	}

	if ( FStrEq( pcmd, "test" ) )
	{
		return PLUGIN_STOP; // we handled this function
	}

    // Draw waypoints / ENABLED / DISABLED
    if ( FStrEq( pcmd, "waypoint_draw") )
    {
        if (bDrawWaypoints)
            bDrawWaypoints=false;
        else
            bDrawWaypoints=true;

        if (bDrawWaypoints) 
            Msg("WAYPOINT: Drawing is enabled\n");
        else
            Msg("WAYPOINT: Drawing is disabled\n");

        return PLUGIN_STOP; // we handled this function
    }    

    // Put a waypoint on our spot
    if ( FStrEq( pcmd, "waypoint_add") )
    {
        Vector vec;
        gameclients->ClientEarPosition( pEntity, &vec); // get vector
        WaypointAdd(vec);   // add waypoint

        return PLUGIN_STOP; // we handled this function
    }

    if ( FStrEq( pcmd, "waypoint_save") )
    {
        WaypointSave(gMapName);
        return PLUGIN_STOP; // we handled this function
    }

    // T SPAWN
    if ( FStrEq( pcmd, "waypoint_goal_t") )
    {
        if (pHostEdict)
        {
            int iWpt=WaypointClose(hostvec);

            if (iWpt > -1)
            {
                WaypointGoal(iWpt, GOAL_TERROR_SPAWN);
                Msg("WAYPOINT: Goal set to TERROR SPAWN\n");
            }
        }
        else
            Msg("There is no listen server, so i cannot do this\n");

        return PLUGIN_STOP; // we handled this function
    }

    // CT SPAWN
    if ( FStrEq( pcmd, "waypoint_goal_ct") )
    {
        if (pHostEdict)
        {
            int iWpt=WaypointClose(hostvec);

            if (iWpt > -1)
            {
                WaypointGoal(iWpt, GOAL_COUNTER_SPAWN);
                Msg("WAYPOINT: Goal set to COUNTER SPAWN\n");
            }
        }
        else
            Msg("There is no listen server, so i cannot do this\n");

        return PLUGIN_STOP; // we handled this function
    }

    // BOMBSPOT
    if ( FStrEq( pcmd, "waypoint_goal_bomb") )
    {
        if (pHostEdict)
        {
            int iWpt=WaypointClose(hostvec);

            if (iWpt > -1)
            {
                WaypointGoal(iWpt, GOAL_BOMBSPOT);
                Msg("WAYPOINT: Goal set to BOMBSPOT\n");
            }
        }
        else
            Msg("There is no listen server, so i cannot do this\n");

        return PLUGIN_STOP; // we handled this function
    }


	return PLUGIN_CONTINUE;
}

//---------------------------------------------------------------------------------
// Purpose: called when a client is authenticated
//---------------------------------------------------------------------------------
PLUGIN_RESULT CUBBOT_Plugin::NetworkIDValidated( const char *pszUserName, const char *pszNetworkID )
{
	return PLUGIN_CONTINUE;
}

//---------------------------------------------------------------------------------
// Purpose: called when an event is fired
//---------------------------------------------------------------------------------
void CUBBOT_Plugin::FireGameEvent( KeyValues * event )
{
}

//---------------------------------------------------------------------------------
// Purpose: an example of how to implement a new command
//---------------------------------------------------------------------------------
CON_COMMAND( HPB_bot2_version, "prints the version of the HPB_bot plugin" )
{
	Msg( "Version:0.0.0.1\n" );
}

CON_COMMAND( add_bot, "adds a bot to the server" )
{
	CreateBot("Player", -1);  // create a bot named "Player"
}


CON_COMMAND( add_bot_t, "adds a bot to the server" )
{
	CreateBot("Player", 2);  // create a bot named "Player"
}


CON_COMMAND( add_bot_ct, "adds a bot to the server" )
{
	CreateBot("Player", 3);  // create a bot named "Player"
}
