//=================================================================================//
//
// UNITED BOT - FRAME WORK
//
// 
// This work is based off several pieces of code by several authors. In no specific
// order:
// 
// Jeffrey "botman" Broome
// Cheeseh
// Stefan Hendriks
// 
//
//=================================================================================//
#include <stdio.h>

// HACK HACK HACK : BASEENTITY ACCESS
#include "cbase.h"
#include "baseentity.h"
// HACK HACK HACK : BASEENTITY ACCESS

#include "interface.h"
#include "filesystem.h"
#include "engine/iserverplugin.h"
#include "dlls/iplayerinfo.h"
#include "eiface.h"
#include "igameevents.h"
#include "IEffects.h"

#include "usercmd.h"
#include "bitbuf.h"
#include "in_buttons.h"

//#include "mathlib.h"

#include "ubbot.h"
#include "ubbot_util.h"

// memdbgon must be the last include file in a .cpp file!!!
#include "tier0/memdbgon.h"

void WaypointInit()
{
    int iIndex=0;
    for (iIndex=0; iIndex < MAX_WAYPOINTS; iIndex++)
    {
        gWaypoints[iIndex].Origin = Vector(0,0,0);
        gWaypoints[iIndex].iGoal  = -1;
        
        // remove neighbours
        // FIXME: can be done better (ie, by memset, but i am lazy) - Stefan
        int iNeigh=0;
        for (iNeigh; iNeigh < 8; iNeigh++)
            gWaypoints[iIndex].iNeighbours[iNeigh] = -1;
    }
}

void WaypointDraw(edict_t *pEdict)
{
    // When gWaypointSprite failed, try again here
    if (engine->IsModelPrecached(PHYSGUN_BEAM_SPRITE) || gWaypointSprite < 0)
    {
        // Precache sprite
        gWaypointSprite = engine->PrecacheModel(PHYSGUN_BEAM_SPRITE);
    }

    int iIndex=0;
    for (iIndex; iIndex < MAX_WAYPOINTS; iIndex++)
    {
        // every waypoint that has Vector != 0,0,0
        if (gWaypoints[iIndex].Origin != Vector(0,0,0))
        {
            // Draw beam
            //engine->
            int r,g,b;
            r=g=b=255;

            // t
            if (gWaypoints[iIndex].iGoal == GOAL_TERROR_SPAWN)
            {
                r=255; 
                g=b=0;
            }

            // ct
            if (gWaypoints[iIndex].iGoal == GOAL_COUNTER_SPAWN)
            {
                b=255; 
                g=r=0;
            }


            // bomb
            if (gWaypoints[iIndex].iGoal == GOAL_BOMBSPOT)
            {
                b=255; 
                g=255;
                r=0;
            }
            
            // todo: hostage



            .
            // draw the beam
            effects->Beam(gWaypoints[iIndex].Origin + Vector(0,0,-128),
                          gWaypoints[iIndex].Origin, 
                          gWaypointSprite, 
                          0, 
                          0, 0, 10, 1, 1, 255, 0, 
                          r,g,b,255,5);
/*
                virtual void Beam( const Vector &Start, const Vector &End, int nModelIndex, 
		int nHaloIndex, unsigned char frameStart, unsigned char frameRate,
		float flLife, unsigned char width, unsigned char endWidth, unsigned char fadeLength, 
		unsigned char noise, unsigned char red, unsigned char green,
		unsigned char blue, unsigned char brightness, unsigned char speed) = 0;*/

        }
    }
}

void WaypointGoal(int iIndex, int iGoal)
{
    if (iIndex < 0)
        return;

    if (iGoal < 0)
        return;

    Msg("WaypointGoal() - Goal set");
    gWaypoints[iIndex].iGoal = iGoal; // set goal
}

int WaypointClose(Vector v)
{
    // return closest Waypoint to v
    int iIndex=0;
    int iFound=-1;
    float fClosestDistance = 9999;
    for (iIndex; iIndex < MAX_WAYPOINTS; iIndex++)
    {
        if (gWaypoints[iIndex].Origin != Vector(0,0,0))
        {
            if (UTIL_DistanceBetween(v, gWaypoints[iIndex].Origin) < fClosestDistance)
            {
                fClosestDistance = UTIL_DistanceBetween(v, gWaypoints[iIndex].Origin);
                iFound = iIndex;
            }
        }
    }

    return iFound;
}

void WaypointSave(char filename[80])
{
 // dump memory into file
    FILE *rbl;
    //strcat ("//ubbot//", filename); 
    char thefilename[256];
    sprintf(thefilename, "ubbot//%s.ubn", filename);

    rbl = fopen (thefilename, "wb"); 
    
    if (rbl != NULL)
    {
        fwrite (&gWaypoints, sizeof (gWaypoints), 1, rbl); 
        fclose(rbl);

        Msg("Waypoints saved for :");
        Msg(filename);
        Msg("\n");
    }
    else
    {
      Msg("WARNING: There are no waypoints saved for : ");
      Msg(filename);
      Msg("\n");
    }

    
}

void WaypointLoad(char filename[80])
{
 // load file into memory
  FILE *rbl;  
  char thefilename[256];
  sprintf(thefilename, "ubbot//%s.ubn", filename);
  //strcat ("//ubbot//", filename);
  rbl = fopen (thefilename, "rb"); 

  if (rbl != NULL)
  {
      fread (&gWaypoints, sizeof (gWaypoints), 1, rbl); 
      fclose(rbl);
      Msg("Waypoints loaded for :");
      Msg(filename);
      Msg("\n");
  }
  else
  {
      Msg("WARNING: There are no waypoints loaded for : ");
      Msg(filename);
      Msg("\n");
  }
}


void WaypointAdd(Vector v)
{
    // add waypoint
    int iNewIndex=-1, iIndex=0;
    for (iIndex; iIndex < MAX_WAYPOINTS; iIndex++)
    {
        if (gWaypoints[iIndex].Origin == Vector(0,0,0))
        {
            iNewIndex=iIndex;
            break;
        }
    }

    if (iNewIndex < 0)
        return;

    gWaypoints[iNewIndex].Origin = v;
    gWaypoints[iNewIndex].iGoal = -1;
    
    // todo , clear neighbours ?

    Msg("WAYPOINT: Waypoint added\n");
}
